package com.sample.processserver;

import java.io.IOException;

import javax.naming.InitialContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;

import org.drools.runtime.StatefulKnowledgeSession;
import org.jbpm.process.audit.JPAProcessInstanceDbLog;
import org.jbpm.process.audit.JPAWorkingMemoryDbLogger;
import org.jbpm.process.workitem.wsht.CommandBasedWSHumanTaskHandler;

import com.eapcpoc.jbpm.util.EPACAppConstants;
import com.sample.servlet.TaskWorkUtil;

public class TaskProcessServlet extends HttpServlet {

	// private static Log log = LogFactory.getLog(TaskProcessServlet.class);
	private static final long serialVersionUID = 1L;

	public void init() throws ServletException {

		super.init();

		try {

			UserTransaction ut = (UserTransaction) new InitialContext().lookup("java:comp/UserTransaction");
			ut.begin();
			StatefulKnowledgeSession ksession = JbpmAPIUtil.getSession();

			/* Create the knowledge base */
			
			JPAWorkingMemoryDbLogger  logger = new JPAWorkingMemoryDbLogger (ksession);
			JPAProcessInstanceDbLog  processInstaceLogger = new JPAProcessInstanceDbLog (ksession.getEnvironment());			
			
			CommandBasedWSHumanTaskHandler taskHandler = new CommandBasedWSHumanTaskHandler(ksession);
			//WSHumanTaskHandler taskHandler = new WSHumanTaskHandler();
			taskHandler.setClient(TaskWorkUtil.createTaskClient());
			taskHandler.setConnection("127.0.0.1", EPACAppConstants.HORNET_Q_SERVER_PORT);
			
			ksession.getWorkItemManager().registerWorkItemHandler("Human Task", taskHandler);
			processInstaceLogger.findProcessInstances();
			taskHandler.connect();
			
			ut.commit();
			logger.dispose();
			processInstaceLogger.dispose();
		} catch (Throwable t) {
			// log.error(t.getMessage(), t.getCause());
			throw new RuntimeException("error while creating session", t);
		}

	}

	public void destroy() {
		super.destroy();
	}

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// processRequest(request, response);

	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException,
			IOException {
		// processRequest(request, response);

	}
}
