package com.sample.servlet;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.drools.KnowledgeBase;
import org.drools.SystemEventListenerFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.io.ResourceFactory;
import org.drools.logger.KnowledgeRuntimeLogger;
import org.drools.logger.KnowledgeRuntimeLoggerFactory;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;
import org.jbpm.process.audit.JPAProcessInstanceDbLog;
import org.jbpm.process.audit.JPAWorkingMemoryDbLogger;
import org.jbpm.process.workitem.wsht.WSHumanTaskHandler;
import org.jbpm.task.AccessType;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.task.service.ContentData;
import org.jbpm.task.service.TaskClient;
import org.jbpm.task.service.hornetq.HornetQTaskClientConnector;
import org.jbpm.task.service.hornetq.HornetQTaskClientHandler;
import org.jbpm.task.service.mina.MinaTaskClientConnector;
import org.jbpm.task.service.mina.MinaTaskClientHandler;
import org.jbpm.task.service.responsehandlers.BlockingTaskOperationResponseHandler;
import org.jbpm.task.service.responsehandlers.BlockingTaskSummaryResponseHandler;

import com.eapcpoc.jbpm.util.EPACAppConstants;

/**
 * This is a sample file to launch a process.
 */
public class TaskWorkUtil {
	private static KnowledgeBase kbase;
	private static StatefulKnowledgeSession ksession;

	private static JPAWorkingMemoryDbLogger workingMemoryDbLogger = null;
	private static JPAProcessInstanceDbLog processInstaceLogger = null;

	public static final void main(String[] args) {
		try {
			// 1.) Start Workflow Process
			ProcessInstance pi = startWorkflowProcess();

			// 2.)Product Planner -Start and Review Product List
			boolean isStarted = false;
			boolean isAutoRepStatus = true;
			// startCompleteReviewProductPP(isStarted,isAutoRepStatus);

			String result = null;
			// result= (String)
			// ((WorkflowProcessInstance)pi).getVariable("autoRepStatus");//Comment
			System.out.println("Result:" + result);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static ProcessInstance startWorkflowProcess() {
		ProcessInstance pi = null;
		try {
			// load up the knowledge base
			kbase = readKnowledgeBase();
			ksession = kbase.newStatefulKnowledgeSession();
			KnowledgeRuntimeLogger logger = KnowledgeRuntimeLoggerFactory.newFileLogger(ksession, "test");
			ksession.getWorkItemManager().registerWorkItemHandler("Human Task", new WSHumanTaskHandler());
			Map<String, Object> params = new HashMap<String, Object>();
			params.put("Result", "2");
			// start a new process instance
			pi = ksession.startProcess("com.sample.bpmn.orderfactory", params);
			logger.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return pi;
	}

	public static boolean startWorkflowProcessOrderFactory() {
		boolean isStarted = false;
		try {
			// load up the knowledge base
			kbase = readKnowledgeBase();
			ksession = kbase.newStatefulKnowledgeSession();
			KnowledgeRuntimeLogger logger = KnowledgeRuntimeLoggerFactory.newFileLogger(ksession, "test");
			org.jbpm.process.audit.JPAWorkingMemoryDbLogger logger1 = new org.jbpm.process.audit.JPAWorkingMemoryDbLogger(
					ksession);
			ksession.getWorkItemManager().registerWorkItemHandler("Human Task", new WSHumanTaskHandler());
			Map<String, Object> params = new HashMap<String, Object>();
			params.put("Result", "2");
			// start a new process instance
			ksession.startProcess("com.sample.bpmn.orderfactory", params);
			isStarted = true;
			logger1.dispose();
			logger.close();
		} catch (Exception e) {
			isStarted = false;
			e.printStackTrace();
		}
		return isStarted;
	}

	private static KnowledgeBase readKnowledgeBase() throws Exception {
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
		kbuilder.add(ResourceFactory.newClassPathResource("orderfactory.bpmn"), ResourceType.BPMN2);
		return kbuilder.newKnowledgeBase();
	}

	// krisv is Product Planner
	public static List<TaskSummary> getTaskDetails(String userName) {
		List<TaskSummary> task1 = null;
		try {
			SystemEventListenerFactory.setSystemEventListener(new SystemEventListener());
			TaskClient taskClient = createTaskClient();
			// "krisv" executes
			BlockingTaskSummaryResponseHandler taskSummaryHandler = new BlockingTaskSummaryResponseHandler();
			taskClient.getTasksAssignedAsPotentialOwner(userName, "en-UK", taskSummaryHandler);
			if (taskSummaryHandler != null && taskSummaryHandler.getResults() != null
					&& taskSummaryHandler.getResults().size() > 0) {
				// task1 = taskSummaryHandler.getResults().get(0);
				task1 = taskSummaryHandler.getResults();
			}
			System.out.println("ProcessTest.getTaskDetails() task1:" + task1);

			System.out.println("ProcessTest.getTaskDetails() ksession:" + ksession);

		} catch (Exception e) {
			System.out.println("ProcessTest.getTaskDetails()() Exception");
			e.printStackTrace();
		}

		return task1;
	}

	// krisv is Product Planner
	public static List<TaskSummary> startCompleteReviewProductPP(boolean isStarted, boolean isAutoRepStatus,
			int selectedTaskId) {
		List<TaskSummary> task1 = null;
		try {
			System.out.println("ProcessTest.startCompleteReviewProductPP()1-Done1122");
			SystemEventListenerFactory.setSystemEventListener(new SystemEventListener());
			System.out.println("ProcessTest.startCompleteReviewProductPP()11-Done1122");
			TaskClient taskClient = createTaskClient();

			// "krisv" executes
			BlockingTaskSummaryResponseHandler taskSummaryHandler = new BlockingTaskSummaryResponseHandler();
			taskClient.getTasksAssignedAsPotentialOwner("krisv", "en-UK", taskSummaryHandler);
			// task1 = taskSummaryHandler.getResults().get(0);
			task1 = taskSummaryHandler.getResults();
			// Status statusVal1= task1.getStatus();
			// System.out.println("ProcessTest.startCompleteReviewProductPP()statusVal1:Before:"
			// + statusVal1);

			BlockingTaskOperationResponseHandler taskOperationHandler = new BlockingTaskOperationResponseHandler();
			if (!isStarted) {
				for (java.util.Iterator<TaskSummary> it = task1.iterator(); it.hasNext();) {
					TaskSummary task = it.next();
					if (selectedTaskId == task.getId()) {
						taskClient.start(task.getId(), "krisv", taskOperationHandler);
					}
				}

				taskOperationHandler.waitTillDone(1000);

				task1 = taskSummaryHandler.getResults();
				// task1 = taskSummaryHandler.getResults().get(0);
				// Status statusVal= task1.getStatus();
				// System.out.println("ProcessTest.startCompleteReviewProductPP()statusVal:"
				// + statusVal);
			} else {
				taskOperationHandler = new BlockingTaskOperationResponseHandler();

				String autoRepStatusValue = "0";
				if (isAutoRepStatus) {
					autoRepStatusValue = "1";
				}

				System.out.println("ProcessTest.startCompleteReviewProductPP() isAutoRepStatus:" + isAutoRepStatus);
				System.out.println("ProcessTest.startCompleteReviewProductPP() autoRepStatusValue:"
						+ autoRepStatusValue);

				Map<String, Object> results = new HashMap<String, Object>();
				results.put("Result", autoRepStatusValue);
				ContentData contentData = new ContentData();
				contentData = new ContentData();
				contentData.setAccessType(AccessType.Inline);
				ByteArrayOutputStream bos = new ByteArrayOutputStream();
				ObjectOutputStream out;
				try {
					out = new ObjectOutputStream(bos);
					out.writeObject(results);
					out.close();
					contentData.setContent(bos.toByteArray());
					contentData.setAccessType(AccessType.Inline);
				} catch (IOException e) {
					e.printStackTrace();
				}

				for (java.util.Iterator<TaskSummary> it = task1.iterator(); it.hasNext();) {
					TaskSummary task = it.next();
					if (selectedTaskId == task.getId()) {
						taskClient.complete(task.getId(), "krisv", contentData, taskOperationHandler);
					}
				}

				taskOperationHandler.waitTillDone(1000);
				// Thread.sleep(1000);

				System.out.println("ProcessTest.startCompleteReviewProductPP() End of method");

			}

			System.out.println("ProcessTest.startCompleteReviewProductPP() ksession:" + ksession);

		} catch (Exception e) {
			System.out.println("ProcessTest.startCompleteReviewProductPP() Exception");
			e.printStackTrace();
		}

		return task1;
	}

	// Start and complete task
	public static List<TaskSummary> startCompleteTask(boolean isStarted, String userName, int selectedTaskId) {
		List<TaskSummary> task1 = null;
		try {
			SystemEventListenerFactory.setSystemEventListener(new SystemEventListener());
			TaskClient taskClient = createTaskClient();
			// Thread.sleep(1000);

			BlockingTaskSummaryResponseHandler taskSummaryHandler = new BlockingTaskSummaryResponseHandler();
			taskClient.getTasksAssignedAsPotentialOwner(userName, "en-UK", taskSummaryHandler);
			// task1 = taskSummaryHandler.getResults().get(0);
			task1 = taskSummaryHandler.getResults();
			BlockingTaskOperationResponseHandler taskOperationHandler = new BlockingTaskOperationResponseHandler();
			if (!isStarted) {
				for (java.util.Iterator<TaskSummary> it = task1.iterator(); it.hasNext();) {
					TaskSummary task = it.next();
					if (selectedTaskId == task.getId()) {
						taskClient.start(task.getId(), userName, taskOperationHandler);
					}
				}				
				taskOperationHandler.waitTillDone(1000);
			} else {
				taskOperationHandler = new BlockingTaskOperationResponseHandler();
				
				for (java.util.Iterator<TaskSummary> it = task1.iterator(); it.hasNext();) {
					taskClient.complete(it.next().getId(), userName, null, taskOperationHandler);
				}
				taskOperationHandler.waitTillDone(1000);
				// Thread.sleep(1000);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		return task1;

	}

	

	public static void startProcessExecutionLog(StatefulKnowledgeSession ksession) {
		if (workingMemoryDbLogger == null) {
			workingMemoryDbLogger = new JPAWorkingMemoryDbLogger(ksession);
		}
		if (processInstaceLogger == null) {
			processInstaceLogger = new JPAProcessInstanceDbLog(ksession.getEnvironment());
		}
	}

	public static void closeProcessExecutionLoger(StatefulKnowledgeSession ksession) {
		if (workingMemoryDbLogger != null) {
			workingMemoryDbLogger.dispose();
		}
		if (processInstaceLogger != null) {
			processInstaceLogger.dispose();
		}		
	}

	private static class SystemEventListener implements org.drools.SystemEventListener {
		public void debug(String arg0) {
		}

		public void debug(String arg0, Object arg1) {
		}

		public void exception(Throwable arg0) {
		}

		public void exception(String arg0, Throwable arg1) {
		}

		public void info(String arg0) {
		}

		public void info(String arg0, Object arg1) {
		}

		public void warning(String arg0) {
		}

		public void warning(String arg0, Object arg1) {
		}
	}

	/**
	 * @return the kbase
	 */
	public static KnowledgeBase getKbase() {
		return kbase;
	}

	/**
	 * @param kbase the kbase to set
	 */
	public static void setKbase(KnowledgeBase kbase) {
		TaskWorkUtil.kbase = kbase;
	}

	/**
	 * @return the ksession
	 */
	public static StatefulKnowledgeSession getKsession() {
		return ksession;
	}

	/**
	 * @param ksession the ksession to set
	 */
	public static void setKsession(StatefulKnowledgeSession ksession) {
		TaskWorkUtil.ksession = ksession;
	}

	/**
	 * @return the workingMemoryDbLogger
	 */
	public static JPAWorkingMemoryDbLogger getWorkingMemoryDbLogger() {
		return workingMemoryDbLogger;
	}

	/**
	 * @param workingMemoryDbLogger the workingMemoryDbLogger to set
	 */
	public static void setWorkingMemoryDbLogger(JPAWorkingMemoryDbLogger workingMemoryDbLogger) {
		TaskWorkUtil.workingMemoryDbLogger = workingMemoryDbLogger;
	}

	/**
	 * @return the processInstaceLogger
	 */
	public static JPAProcessInstanceDbLog getProcessInstaceLogger() {
		return processInstaceLogger;
	}

	/**
	 * @param processInstaceLogger the processInstaceLogger to set
	 */
	public static void setProcessInstaceLogger(JPAProcessInstanceDbLog processInstaceLogger) {
		TaskWorkUtil.processInstaceLogger = processInstaceLogger;
	}
	
	public static TaskClient createTaskClient() 
	{
		TaskClient taskClient = null;
		//taskClient = createMinaTaskClient();
		taskClient = createHornetQTaskClient();
		connectClientToTaskServer(taskClient);
		return taskClient;
	}

	private static void connectClientToTaskServer(TaskClient taskClient) {
		//for Mina
		//taskClient.connect("127.0.0.1", 9123);
		
		//for HornetQ
		taskClient.connect("127.0.0.1", EPACAppConstants.HORNET_Q_SERVER_PORT);
	}
	
	private static TaskClient createHornetQTaskClient() {
		
		return new TaskClient(new HornetQTaskClientConnector("org.drools.process.workitem.wsht.WSHumanTaskHandler",
				new HornetQTaskClientHandler(SystemEventListenerFactory.getSystemEventListener())));
	}

	private static TaskClient createMinaTaskClient() {
		//return new TaskClient(new MinaTaskClientConnector("MinaConnector",
		return new TaskClient(new MinaTaskClientConnector("org.drools.process.workitem.wsht.WSHumanTaskHandler",
				new MinaTaskClientHandler(SystemEventListenerFactory.getSystemEventListener())));
	}
}